PIDOF(8)

NAZWA
pidof - znajduje identyfikator procesu działającego programu

SKŁADNIA
pidof [-s] [-c] [-n] [-x] [-z] [-o omitpid[,omitpid...]] [-o omitpid[,omitpid...]...] [-d sep] program [program...]

OPIS
pidof wyszukuje identyfikatory procesów (PID-y) wskazanych programów. Wypisuje je następnie na standardowe wyjście. Program ten jest na ogół używany w skryptach zmian poziomu pracy (runlevel change scripts), szczególnie jeśli system ma strukturę rc typu System-V. Skrypty te są wtedy zlokalizowane w /etc/rc.?d, gdzie ? oznacza poziom pracy. Jeżeli system posiada program start-stop-daemon(8), to powinien być on stosowany zamiast pidof.

OPCJE

-s  Pojedynczy strzał - mówi to programowi, by wyświetlił tylko jeden pid.

-c  Only return process PIDs that are running with the same root directory. This option is ignored for non-root users, as they will be unable to check the current root directory of processes they do not own.

-n  Zapobiega wywołaniu funkcji systemowej stat(2) na wszystkich plikach binarnych, zlokalizowanych w sieciowym systemie plików, takim jak NFS. Zamiast użycia tej opcji, można również ustawić i wyeksportować zmienną PIDOF_NETFS.

-q  Do not display matched PIDs to standard out. Simply exit with a status of true or false to indicate whether a matching PID was found.

-x  Skrypty również - to powoduje, że program zwraca również identyfikatory procesów powłok, pracujących z podanymi skryptami.

-z  Try to detect processes which are stuck in zombie (Z) status. Usually these processes are skipped as trying to deal with them can cause pidof or related tools to hang. Note: In the past pidof would ignore processes in the uninterruptable state (D), unless the -z flag was specified. This is no longer the case. The pidof program will find and report processes in the D state whether -z is specified or not.

-d sep
    Tells pidof to use sep as an output separator if more than one PID is shown. The default separator is a space.

-o pomiń-pid
    Mówi programowi, by ominął procesy z podanym identyfikatorem procesu. Istnieje specjalny pid %PPID, który może być używany do wskazywania procesu rodzicielskiego programu pidof, czyli innymi słowy do wywołującej powłoki lub skryptu.

KOD ZAKOŃCZENIA

0   Znaleziono przynajmniej jeden program o żądanej nazwie.

1   Nie znaleziono programu o żądanej nazwie.

UWAGI
pidof jest w rzeczywistości tym samym programem co killall5(8), a jego zachowanie zależy od nazwy, spod której został wywołany.

Gdy pidof jest wywoływany z pełną, ścieżkową nazwą programu, którego PID ma znaleźć, jest rozsądnie bezpieczny. W przeciwnym razie możliwe, że zwróci identyfikatory pid programów, które przypadkowo mają tę samą nazwę, co szukany przez nas, ale faktycznie są innymi programami. Proszę zauważyć, że nazwy plików wykonywalnych działających procesów są pozyskiwane za pomocą readlink(2), tak więc dowiązania symboliczne do plików wykonywalnych również są dopasowywane.

Zombie processes or processes in disk sleep (states Z and D, respectively) are ignored, as attempts to access the stats of these will sometimes fail. The -z flag (see above) tells pidof to try to detect these sleeping and zombie processes, at the risk of failing or hanging.

ZOBACZ TAKŻE
shutdown(8), init(8), halt(8), reboot(8), killall5(8)

AUTOR
Miquel van Smoorenburg (miquels@cistron.nl)